"use strict";
/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.NonCollabClient = exports.LocalClientId = exports.TreeMaintenanceSequenceNumber = exports.UnassignedSequenceNumber = exports.UniversalSequenceNumber = void 0;
/**
 * The sequence number which can be seen by all ops.
 *
 * This is useful in the context of snapshot loading, rollback, among other
 * scenarios.
 *
 * @internal
 */
exports.UniversalSequenceNumber = 0;
/**
 * The sequence number of an op before it is acked.
 *
 * @internal
 */
exports.UnassignedSequenceNumber = -1;
/**
 * @internal
 */
exports.TreeMaintenanceSequenceNumber = -2;
/**
 * @internal
 */
exports.LocalClientId = -1;
/**
 * @internal
 */
exports.NonCollabClient = -2;
//# sourceMappingURL=constants.js.map