"use strict";
/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.SortedSet = exports.endpointPosAndSide = exports.Side = exports.PropertiesRollback = exports.PropertiesManager = exports.SegmentGroupCollection = exports.reservedTileLabelsKey = exports.reservedRangeLabelsKey = exports.refTypeIncludesFlag = exports.refHasTileLabels = exports.refHasTileLabel = exports.refGetTileLabels = exports.minReferencePosition = exports.maxReferencePosition = exports.DetachedReferencePosition = exports.compareReferencePositions = exports.matchProperties = exports.createMap = exports.addProperties = exports.ReferenceType = exports.MergeTreeDeltaType = exports.createObliterateRangeOp = exports.createRemoveRangeOp = exports.createInsertSegmentOp = exports.createInsertOp = exports.createGroupOp = exports.createAnnotateRangeOp = exports.TrackingGroupCollection = exports.TrackingGroup = exports.toRemovalInfo = exports.reservedMarkerSimpleTypeKey = exports.reservedMarkerIdKey = exports.MergeNode = exports.Marker = exports.debugMarkerToString = exports.CollaborationWindow = exports.BaseSegment = exports.MergeTreeMaintenanceType = exports.getSlideToSegoff = exports.SlidingPreference = exports.LocalReferenceCollection = exports.createDetachedLocalReferencePosition = exports.UniversalSequenceNumber = exports.UnassignedSequenceNumber = exports.RedBlackTree = exports.RBColor = exports.Client = exports.createPropertyTrackingAndInsertionAttributionPolicyFactory = exports.createPropertyTrackingAttributionPolicyFactory = exports.createInsertOnlyAttributionPolicy = void 0;
exports.revertMergeTreeDeltaRevertibles = exports.isMergeTreeDeltaRevertible = exports.discardMergeTreeDeltaRevertible = exports.appendToMergeTreeDeltaRevertibles = exports.TextSegment = exports.SortedSegmentSet = void 0;
var attributionPolicy_js_1 = require("./attributionPolicy.js");
Object.defineProperty(exports, "createInsertOnlyAttributionPolicy", { enumerable: true, get: function () { return attributionPolicy_js_1.createInsertOnlyAttributionPolicy; } });
Object.defineProperty(exports, "createPropertyTrackingAttributionPolicyFactory", { enumerable: true, get: function () { return attributionPolicy_js_1.createPropertyTrackingAttributionPolicyFactory; } });
Object.defineProperty(exports, "createPropertyTrackingAndInsertionAttributionPolicyFactory", { enumerable: true, get: function () { return attributionPolicy_js_1.createPropertyTrackingAndInsertionAttributionPolicyFactory; } });
var client_js_1 = require("./client.js");
Object.defineProperty(exports, "Client", { enumerable: true, get: function () { return client_js_1.Client; } });
var index_js_1 = require("./collections/index.js");
Object.defineProperty(exports, "RBColor", { enumerable: true, get: function () { return index_js_1.RBColor; } });
Object.defineProperty(exports, "RedBlackTree", { enumerable: true, get: function () { return index_js_1.RedBlackTree; } });
var constants_js_1 = require("./constants.js");
Object.defineProperty(exports, "UnassignedSequenceNumber", { enumerable: true, get: function () { return constants_js_1.UnassignedSequenceNumber; } });
Object.defineProperty(exports, "UniversalSequenceNumber", { enumerable: true, get: function () { return constants_js_1.UniversalSequenceNumber; } });
var localReference_js_1 = require("./localReference.js");
Object.defineProperty(exports, "createDetachedLocalReferencePosition", { enumerable: true, get: function () { return localReference_js_1.createDetachedLocalReferencePosition; } });
Object.defineProperty(exports, "LocalReferenceCollection", { enumerable: true, get: function () { return localReference_js_1.LocalReferenceCollection; } });
Object.defineProperty(exports, "SlidingPreference", { enumerable: true, get: function () { return localReference_js_1.SlidingPreference; } });
var mergeTree_js_1 = require("./mergeTree.js");
Object.defineProperty(exports, "getSlideToSegoff", { enumerable: true, get: function () { return mergeTree_js_1.getSlideToSegoff; } });
var mergeTreeDeltaCallback_js_1 = require("./mergeTreeDeltaCallback.js");
Object.defineProperty(exports, "MergeTreeMaintenanceType", { enumerable: true, get: function () { return mergeTreeDeltaCallback_js_1.MergeTreeMaintenanceType; } });
var mergeTreeNodes_js_1 = require("./mergeTreeNodes.js");
Object.defineProperty(exports, "BaseSegment", { enumerable: true, get: function () { return mergeTreeNodes_js_1.BaseSegment; } });
Object.defineProperty(exports, "CollaborationWindow", { enumerable: true, get: function () { return mergeTreeNodes_js_1.CollaborationWindow; } });
Object.defineProperty(exports, "debugMarkerToString", { enumerable: true, get: function () { return mergeTreeNodes_js_1.debugMarkerToString; } });
Object.defineProperty(exports, "Marker", { enumerable: true, get: function () { return mergeTreeNodes_js_1.Marker; } });
Object.defineProperty(exports, "MergeNode", { enumerable: true, get: function () { return mergeTreeNodes_js_1.MergeNode; } });
Object.defineProperty(exports, "reservedMarkerIdKey", { enumerable: true, get: function () { return mergeTreeNodes_js_1.reservedMarkerIdKey; } });
Object.defineProperty(exports, "reservedMarkerSimpleTypeKey", { enumerable: true, get: function () { return mergeTreeNodes_js_1.reservedMarkerSimpleTypeKey; } });
Object.defineProperty(exports, "toRemovalInfo", { enumerable: true, get: function () { return mergeTreeNodes_js_1.toRemovalInfo; } });
var mergeTreeTracking_js_1 = require("./mergeTreeTracking.js");
Object.defineProperty(exports, "TrackingGroup", { enumerable: true, get: function () { return mergeTreeTracking_js_1.TrackingGroup; } });
Object.defineProperty(exports, "TrackingGroupCollection", { enumerable: true, get: function () { return mergeTreeTracking_js_1.TrackingGroupCollection; } });
var opBuilder_js_1 = require("./opBuilder.js");
Object.defineProperty(exports, "createAnnotateRangeOp", { enumerable: true, get: function () { return opBuilder_js_1.createAnnotateRangeOp; } });
Object.defineProperty(exports, "createGroupOp", { enumerable: true, get: function () { return opBuilder_js_1.createGroupOp; } });
Object.defineProperty(exports, "createInsertOp", { enumerable: true, get: function () { return opBuilder_js_1.createInsertOp; } });
Object.defineProperty(exports, "createInsertSegmentOp", { enumerable: true, get: function () { return opBuilder_js_1.createInsertSegmentOp; } });
Object.defineProperty(exports, "createRemoveRangeOp", { enumerable: true, get: function () { return opBuilder_js_1.createRemoveRangeOp; } });
Object.defineProperty(exports, "createObliterateRangeOp", { enumerable: true, get: function () { return opBuilder_js_1.createObliterateRangeOp; } });
var ops_js_1 = require("./ops.js");
Object.defineProperty(exports, "MergeTreeDeltaType", { enumerable: true, get: function () { return ops_js_1.MergeTreeDeltaType; } });
Object.defineProperty(exports, "ReferenceType", { enumerable: true, get: function () { return ops_js_1.ReferenceType; } });
var properties_js_1 = require("./properties.js");
Object.defineProperty(exports, "addProperties", { enumerable: true, get: function () { return properties_js_1.addProperties; } });
Object.defineProperty(exports, "createMap", { enumerable: true, get: function () { return properties_js_1.createMap; } });
Object.defineProperty(exports, "matchProperties", { enumerable: true, get: function () { return properties_js_1.matchProperties; } });
var referencePositions_js_1 = require("./referencePositions.js");
Object.defineProperty(exports, "compareReferencePositions", { enumerable: true, get: function () { return referencePositions_js_1.compareReferencePositions; } });
Object.defineProperty(exports, "DetachedReferencePosition", { enumerable: true, get: function () { return referencePositions_js_1.DetachedReferencePosition; } });
Object.defineProperty(exports, "maxReferencePosition", { enumerable: true, get: function () { return referencePositions_js_1.maxReferencePosition; } });
Object.defineProperty(exports, "minReferencePosition", { enumerable: true, get: function () { return referencePositions_js_1.minReferencePosition; } });
Object.defineProperty(exports, "refGetTileLabels", { enumerable: true, get: function () { return referencePositions_js_1.refGetTileLabels; } });
Object.defineProperty(exports, "refHasTileLabel", { enumerable: true, get: function () { return referencePositions_js_1.refHasTileLabel; } });
Object.defineProperty(exports, "refHasTileLabels", { enumerable: true, get: function () { return referencePositions_js_1.refHasTileLabels; } });
Object.defineProperty(exports, "refTypeIncludesFlag", { enumerable: true, get: function () { return referencePositions_js_1.refTypeIncludesFlag; } });
Object.defineProperty(exports, "reservedRangeLabelsKey", { enumerable: true, get: function () { return referencePositions_js_1.reservedRangeLabelsKey; } });
Object.defineProperty(exports, "reservedTileLabelsKey", { enumerable: true, get: function () { return referencePositions_js_1.reservedTileLabelsKey; } });
var segmentGroupCollection_js_1 = require("./segmentGroupCollection.js");
Object.defineProperty(exports, "SegmentGroupCollection", { enumerable: true, get: function () { return segmentGroupCollection_js_1.SegmentGroupCollection; } });
var segmentPropertiesManager_js_1 = require("./segmentPropertiesManager.js");
Object.defineProperty(exports, "PropertiesManager", { enumerable: true, get: function () { return segmentPropertiesManager_js_1.PropertiesManager; } });
Object.defineProperty(exports, "PropertiesRollback", { enumerable: true, get: function () { return segmentPropertiesManager_js_1.PropertiesRollback; } });
var sequencePlace_js_1 = require("./sequencePlace.js");
Object.defineProperty(exports, "Side", { enumerable: true, get: function () { return sequencePlace_js_1.Side; } });
Object.defineProperty(exports, "endpointPosAndSide", { enumerable: true, get: function () { return sequencePlace_js_1.endpointPosAndSide; } });
var sortedSet_js_1 = require("./sortedSet.js");
Object.defineProperty(exports, "SortedSet", { enumerable: true, get: function () { return sortedSet_js_1.SortedSet; } });
var sortedSegmentSet_js_1 = require("./sortedSegmentSet.js");
Object.defineProperty(exports, "SortedSegmentSet", { enumerable: true, get: function () { return sortedSegmentSet_js_1.SortedSegmentSet; } });
var textSegment_js_1 = require("./textSegment.js");
Object.defineProperty(exports, "TextSegment", { enumerable: true, get: function () { return textSegment_js_1.TextSegment; } });
var revertibles_js_1 = require("./revertibles.js");
Object.defineProperty(exports, "appendToMergeTreeDeltaRevertibles", { enumerable: true, get: function () { return revertibles_js_1.appendToMergeTreeDeltaRevertibles; } });
Object.defineProperty(exports, "discardMergeTreeDeltaRevertible", { enumerable: true, get: function () { return revertibles_js_1.discardMergeTreeDeltaRevertible; } });
Object.defineProperty(exports, "isMergeTreeDeltaRevertible", { enumerable: true, get: function () { return revertibles_js_1.isMergeTreeDeltaRevertible; } });
Object.defineProperty(exports, "revertMergeTreeDeltaRevertibles", { enumerable: true, get: function () { return revertibles_js_1.revertMergeTreeDeltaRevertibles; } });
//# sourceMappingURL=index.js.map