/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { IRandom } from "@fluid-private/stochastic-test-utils";
import { IMergeNode } from "../mergeTreeNodes.js";
import { TestClient } from "./testClient.js";
export declare function simpleTest(): void;
export declare function integerTest1(): number;
export declare function fileTest1(): void;
export declare function makeTextSegment(text: string): IMergeNode;
export declare function mergeTreeTest1(): void;
export declare function mergeTreeLargeTest(): void;
export declare function mergeTreeCheckedTest(): number;
export declare function TestPack(verbose?: boolean): {
    firstTest: () => void;
    randolicious: () => number;
    clientServer: (startFile?: string, initRounds?: number) => number;
    manyMergeTrees: () => void;
};
export declare class RandomPack {
    random: IRandom;
    constructor();
    randInteger(min: number, max: number): number;
    randString(wordCount: number): string;
}
export type DocumentNode = string | DocumentTree;
/**
 * Generate and model documents from the following tree grammar:
 * Row -\> row[Box*];
 * Box -\> box[Content];
 * Content -\> (Row|Paragraph)*;
 * Paragraph -\> pgtile text;
 * Document -\> Content
 */
export declare class DocumentTree {
    name: string;
    children: DocumentNode[];
    pos: number;
    ids: Record<string, number>;
    id: string | undefined;
    static randPack: RandomPack;
    constructor(name: string, children: DocumentNode[]);
    addToMergeTree(client: TestClient, docNode: DocumentNode): void;
    static generateDocument(): DocumentTree;
    static generateContent(rowProbability: number): DocumentNode[];
    static generateParagraph(): DocumentTree;
    static generateRow(rowProbability: number): DocumentTree;
    static generateBox(rowProbability: number): DocumentTree;
}
//# sourceMappingURL=beastTest.spec.d.ts.map