"use strict";
/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.MergeTreeDeltaType = exports.MergeNode = exports.maxReferencePosition = exports.matchProperties = exports.Marker = exports.LocalReferenceCollection = exports.discardMergeTreeDeltaRevertible = exports.DetachedReferencePosition = exports.debugMarkerToString = exports.createRemoveRangeOp = exports.createMap = exports.createInsertSegmentOp = exports.createInsertOp = exports.createGroupOp = exports.createDetachedLocalReferencePosition = exports.createAnnotateRangeOp = exports.compareReferencePositions = exports.CollaborationWindow = exports.Client = exports.BaseSegment = exports.appendToMergeTreeDeltaRevertibles = exports.addProperties = exports.SnapshotLegacy = exports.MergeTreeTextHelper = exports.MergeTree = exports.runMergeTreeOperationRunner = exports.replayResultsPath = exports.removeRange = exports.insertAtRefPos = exports.generateOperationMessagesForClients = exports.generateClientNames = exports.doOverRange = exports.applyMessages = exports.annotateRange = exports.useStrictPartialLengthChecks = exports.validatePartialLengths = exports.nodeOrdinalsHaveIntegrity = exports.markRangeRemoved = exports.loadTextFromFileWithMarkers = exports.loadTextFromFile = exports.insertText = exports.insertSegments = exports.insertMarker = exports.countOperations = exports.TestServer = exports.checkTextMatchRelative = exports.TestClient = exports.specToSegment = exports.getStats = exports.createRevertDriver = void 0;
exports.UniversalSequenceNumber = exports.UnassignedSequenceNumber = exports.TrackingGroupCollection = exports.TrackingGroup = exports.toRemovalInfo = exports.TextSegment = exports.SortedSet = exports.SortedSegmentSet = exports.SegmentGroupCollection = exports.revertMergeTreeDeltaRevertibles = exports.reservedTileLabelsKey = exports.reservedMarkerSimpleTypeKey = exports.reservedMarkerIdKey = exports.refTypeIncludesFlag = exports.refHasTileLabels = exports.refHasTileLabel = exports.refGetTileLabels = exports.ReferenceType = exports.RedBlackTree = exports.PropertiesManager = exports.minReferencePosition = exports.MergeTreeMaintenanceType = void 0;
var testClient_js_1 = require("./testClient.js");
Object.defineProperty(exports, "createRevertDriver", { enumerable: true, get: function () { return testClient_js_1.createRevertDriver; } });
Object.defineProperty(exports, "getStats", { enumerable: true, get: function () { return testClient_js_1.getStats; } });
Object.defineProperty(exports, "specToSegment", { enumerable: true, get: function () { return testClient_js_1.specToSegment; } });
Object.defineProperty(exports, "TestClient", { enumerable: true, get: function () { return testClient_js_1.TestClient; } });
var testServer_js_1 = require("./testServer.js");
Object.defineProperty(exports, "checkTextMatchRelative", { enumerable: true, get: function () { return testServer_js_1.checkTextMatchRelative; } });
Object.defineProperty(exports, "TestServer", { enumerable: true, get: function () { return testServer_js_1.TestServer; } });
var testUtils_js_1 = require("./testUtils.js");
Object.defineProperty(exports, "countOperations", { enumerable: true, get: function () { return testUtils_js_1.countOperations; } });
Object.defineProperty(exports, "insertMarker", { enumerable: true, get: function () { return testUtils_js_1.insertMarker; } });
Object.defineProperty(exports, "insertSegments", { enumerable: true, get: function () { return testUtils_js_1.insertSegments; } });
Object.defineProperty(exports, "insertText", { enumerable: true, get: function () { return testUtils_js_1.insertText; } });
Object.defineProperty(exports, "loadTextFromFile", { enumerable: true, get: function () { return testUtils_js_1.loadTextFromFile; } });
Object.defineProperty(exports, "loadTextFromFileWithMarkers", { enumerable: true, get: function () { return testUtils_js_1.loadTextFromFileWithMarkers; } });
Object.defineProperty(exports, "markRangeRemoved", { enumerable: true, get: function () { return testUtils_js_1.markRangeRemoved; } });
Object.defineProperty(exports, "nodeOrdinalsHaveIntegrity", { enumerable: true, get: function () { return testUtils_js_1.nodeOrdinalsHaveIntegrity; } });
Object.defineProperty(exports, "validatePartialLengths", { enumerable: true, get: function () { return testUtils_js_1.validatePartialLengths; } });
Object.defineProperty(exports, "useStrictPartialLengthChecks", { enumerable: true, get: function () { return testUtils_js_1.useStrictPartialLengthChecks; } });
var mergeTreeOperationRunner_js_1 = require("./mergeTreeOperationRunner.js");
Object.defineProperty(exports, "annotateRange", { enumerable: true, get: function () { return mergeTreeOperationRunner_js_1.annotateRange; } });
Object.defineProperty(exports, "applyMessages", { enumerable: true, get: function () { return mergeTreeOperationRunner_js_1.applyMessages; } });
Object.defineProperty(exports, "doOverRange", { enumerable: true, get: function () { return mergeTreeOperationRunner_js_1.doOverRange; } });
Object.defineProperty(exports, "generateClientNames", { enumerable: true, get: function () { return mergeTreeOperationRunner_js_1.generateClientNames; } });
Object.defineProperty(exports, "generateOperationMessagesForClients", { enumerable: true, get: function () { return mergeTreeOperationRunner_js_1.generateOperationMessagesForClients; } });
Object.defineProperty(exports, "insertAtRefPos", { enumerable: true, get: function () { return mergeTreeOperationRunner_js_1.insertAtRefPos; } });
Object.defineProperty(exports, "removeRange", { enumerable: true, get: function () { return mergeTreeOperationRunner_js_1.removeRange; } });
Object.defineProperty(exports, "replayResultsPath", { enumerable: true, get: function () { return mergeTreeOperationRunner_js_1.replayResultsPath; } });
Object.defineProperty(exports, "runMergeTreeOperationRunner", { enumerable: true, get: function () { return mergeTreeOperationRunner_js_1.runMergeTreeOperationRunner; } });
var mergeTree_js_1 = require("../mergeTree.js");
Object.defineProperty(exports, "MergeTree", { enumerable: true, get: function () { return mergeTree_js_1.MergeTree; } });
var MergeTreeTextHelper_js_1 = require("../MergeTreeTextHelper.js");
Object.defineProperty(exports, "MergeTreeTextHelper", { enumerable: true, get: function () { return MergeTreeTextHelper_js_1.MergeTreeTextHelper; } });
var snapshotlegacy_js_1 = require("../snapshotlegacy.js");
Object.defineProperty(exports, "SnapshotLegacy", { enumerable: true, get: function () { return snapshotlegacy_js_1.SnapshotLegacy; } });
var index_js_1 = require("../index.js");
Object.defineProperty(exports, "addProperties", { enumerable: true, get: function () { return index_js_1.addProperties; } });
Object.defineProperty(exports, "appendToMergeTreeDeltaRevertibles", { enumerable: true, get: function () { return index_js_1.appendToMergeTreeDeltaRevertibles; } });
Object.defineProperty(exports, "BaseSegment", { enumerable: true, get: function () { return index_js_1.BaseSegment; } });
Object.defineProperty(exports, "Client", { enumerable: true, get: function () { return index_js_1.Client; } });
Object.defineProperty(exports, "CollaborationWindow", { enumerable: true, get: function () { return index_js_1.CollaborationWindow; } });
Object.defineProperty(exports, "compareReferencePositions", { enumerable: true, get: function () { return index_js_1.compareReferencePositions; } });
Object.defineProperty(exports, "createAnnotateRangeOp", { enumerable: true, get: function () { return index_js_1.createAnnotateRangeOp; } });
Object.defineProperty(exports, "createDetachedLocalReferencePosition", { enumerable: true, get: function () { return index_js_1.createDetachedLocalReferencePosition; } });
Object.defineProperty(exports, "createGroupOp", { enumerable: true, get: function () { return index_js_1.createGroupOp; } });
Object.defineProperty(exports, "createInsertOp", { enumerable: true, get: function () { return index_js_1.createInsertOp; } });
Object.defineProperty(exports, "createInsertSegmentOp", { enumerable: true, get: function () { return index_js_1.createInsertSegmentOp; } });
Object.defineProperty(exports, "createMap", { enumerable: true, get: function () { return index_js_1.createMap; } });
Object.defineProperty(exports, "createRemoveRangeOp", { enumerable: true, get: function () { return index_js_1.createRemoveRangeOp; } });
Object.defineProperty(exports, "debugMarkerToString", { enumerable: true, get: function () { return index_js_1.debugMarkerToString; } });
Object.defineProperty(exports, "DetachedReferencePosition", { enumerable: true, get: function () { return index_js_1.DetachedReferencePosition; } });
Object.defineProperty(exports, "discardMergeTreeDeltaRevertible", { enumerable: true, get: function () { return index_js_1.discardMergeTreeDeltaRevertible; } });
Object.defineProperty(exports, "LocalReferenceCollection", { enumerable: true, get: function () { return index_js_1.LocalReferenceCollection; } });
Object.defineProperty(exports, "Marker", { enumerable: true, get: function () { return index_js_1.Marker; } });
Object.defineProperty(exports, "matchProperties", { enumerable: true, get: function () { return index_js_1.matchProperties; } });
Object.defineProperty(exports, "maxReferencePosition", { enumerable: true, get: function () { return index_js_1.maxReferencePosition; } });
Object.defineProperty(exports, "MergeNode", { enumerable: true, get: function () { return index_js_1.MergeNode; } });
Object.defineProperty(exports, "MergeTreeDeltaType", { enumerable: true, get: function () { return index_js_1.MergeTreeDeltaType; } });
Object.defineProperty(exports, "MergeTreeMaintenanceType", { enumerable: true, get: function () { return index_js_1.MergeTreeMaintenanceType; } });
Object.defineProperty(exports, "minReferencePosition", { enumerable: true, get: function () { return index_js_1.minReferencePosition; } });
Object.defineProperty(exports, "PropertiesManager", { enumerable: true, get: function () { return index_js_1.PropertiesManager; } });
Object.defineProperty(exports, "RedBlackTree", { enumerable: true, get: function () { return index_js_1.RedBlackTree; } });
Object.defineProperty(exports, "ReferenceType", { enumerable: true, get: function () { return index_js_1.ReferenceType; } });
Object.defineProperty(exports, "refGetTileLabels", { enumerable: true, get: function () { return index_js_1.refGetTileLabels; } });
Object.defineProperty(exports, "refHasTileLabel", { enumerable: true, get: function () { return index_js_1.refHasTileLabel; } });
Object.defineProperty(exports, "refHasTileLabels", { enumerable: true, get: function () { return index_js_1.refHasTileLabels; } });
Object.defineProperty(exports, "refTypeIncludesFlag", { enumerable: true, get: function () { return index_js_1.refTypeIncludesFlag; } });
Object.defineProperty(exports, "reservedMarkerIdKey", { enumerable: true, get: function () { return index_js_1.reservedMarkerIdKey; } });
Object.defineProperty(exports, "reservedMarkerSimpleTypeKey", { enumerable: true, get: function () { return index_js_1.reservedMarkerSimpleTypeKey; } });
Object.defineProperty(exports, "reservedTileLabelsKey", { enumerable: true, get: function () { return index_js_1.reservedTileLabelsKey; } });
Object.defineProperty(exports, "revertMergeTreeDeltaRevertibles", { enumerable: true, get: function () { return index_js_1.revertMergeTreeDeltaRevertibles; } });
Object.defineProperty(exports, "SegmentGroupCollection", { enumerable: true, get: function () { return index_js_1.SegmentGroupCollection; } });
Object.defineProperty(exports, "SortedSegmentSet", { enumerable: true, get: function () { return index_js_1.SortedSegmentSet; } });
Object.defineProperty(exports, "SortedSet", { enumerable: true, get: function () { return index_js_1.SortedSet; } });
Object.defineProperty(exports, "TextSegment", { enumerable: true, get: function () { return index_js_1.TextSegment; } });
Object.defineProperty(exports, "toRemovalInfo", { enumerable: true, get: function () { return index_js_1.toRemovalInfo; } });
Object.defineProperty(exports, "TrackingGroup", { enumerable: true, get: function () { return index_js_1.TrackingGroup; } });
Object.defineProperty(exports, "TrackingGroupCollection", { enumerable: true, get: function () { return index_js_1.TrackingGroupCollection; } });
Object.defineProperty(exports, "UnassignedSequenceNumber", { enumerable: true, get: function () { return index_js_1.UnassignedSequenceNumber; } });
Object.defineProperty(exports, "UniversalSequenceNumber", { enumerable: true, get: function () { return index_js_1.UniversalSequenceNumber; } });
//# sourceMappingURL=index.js.map