/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * Run a custom "spy function" every time the given method is invoked.
 * @param methodClass - the class that has the method
 * @param methodName - the name of the method
 * @param spy - the spy function to run alongside the method
 * @returns a function which will remove the spy function when invoked. Should be called exactly once
 * after the spy is no longer needed.
 *
 * This method is duplicated between shared-tree test code, and should eventually
 * be merged with the implementation that lives there
 */
export declare function spyOnMethod(methodClass: Function, methodName: string, spy: () => void): () => void;
//# sourceMappingURL=revertibles.spec.d.ts.map