"use strict";
/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.TestSerializer = void 0;
const internal_1 = require("@fluidframework/core-utils/internal");
/**
 * Test serializer implementation for merge tree tests
 */
class TestSerializer {
    constructor() { }
    get IFluidSerializer() {
        return this;
    }
    encode(input, bind) {
        throw new Error("Method not implemented.");
    }
    decode(input) {
        throw new Error("Method not implemented.");
    }
    stringify(value, bind) {
        (0, internal_1.assert)(bind === undefined, "Test serializer should not be called with bind handles");
        return JSON.stringify(value);
    }
    parse(value) {
        return JSON.parse(value);
    }
}
exports.TestSerializer = TestSerializer;
//# sourceMappingURL=testSerializer.js.map