/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { assert } from "@fluidframework/core-utils/internal";
/**
 * Test serializer implementation for merge tree tests
 */
export class TestSerializer {
    constructor() { }
    get IFluidSerializer() {
        return this;
    }
    encode(input, bind) {
        throw new Error("Method not implemented.");
    }
    decode(input) {
        throw new Error("Method not implemented.");
    }
    stringify(value, bind) {
        assert(bind === undefined, "Test serializer should not be called with bind handles");
        return JSON.stringify(value);
    }
    parse(value) {
        return JSON.parse(value);
    }
}
//# sourceMappingURL=testSerializer.js.map